package info.gomi.lisp.sdlisp;

/** S̕] EVAL */
public class Eval {
	private static final int maxStackSize = 65536;	// Lisp X^bNTCY
	private static T[] stack = new T[maxStackSize];	// Lisp X^bN
	private static int stackP = 0;					// Lisp X^bN|C^

	/** ^ꂽ S] Eval.eval(Sexp) */
	public static T eval(T form) throws Exception {
		// V{̂Ƃ̕]
		if (form instanceof Symbol) {
			T symbolValue = ((Symbol)form).value;
			if (symbolValue == null) throw new Exception("Unbound Variable Error: " + (Symbol)form);
			return symbolValue;
		}
		// V{ȊÕAĝƂ̕]
		if (form instanceof Null) return form;		
		if (form instanceof Atom) return form;
		// Xg̕]i֐̕]j
		T car = ((Cons)form).car;
		if (car instanceof Symbol) {
			// VXe֐͓NXp O(1) Ō
			T fun = ((Symbol)car).function;
			if (fun == null) throw new Exception("Undefined Function Error: " + (Symbol)car);
			// VXe֐̕]
			if (fun instanceof Function) {
				T argumentList = ((Cons)form).cdr;
				return ((Function)fun).funcall((List)argumentList);
			}
			// S֐̕]
			if (fun instanceof Cons) {
				Cons cdr = (Cons)((Cons)fun).cdr;
				T lambdaList = cdr.car;
				Cons body = (Cons)cdr.cdr;
				// ȂƂ́Aɖ{ body ̂܂ܕ]
				if (lambdaList == Null.Nil) return evalBody(body);
				// Ƃ́A]ƑA{ body ]
				return bindEvalBody((Cons)lambdaList, body, (Cons)((Cons)form).cdr);
			}
			throw new Exception("Not a Function: " + fun);
		}
		// car V{łȂƂ
		throw new Exception("Not a Symbol: " + car);
	}

	/**
	 * S`֐̕] sexpEval
	 * @param lambda _Xgiϐj . (x y)
	 * @param body S֐{ . (+ x y)
	 * @param form ]S . (add 10 20)
	 * @return ]
	 * @throws Exception Lisp̊eG[i̕ϐA֐`ȂȂǁj
	 */
	private static T bindEvalBody(Cons lambda, Cons body, Cons form) throws Exception {
		// (1) O̊ň](]l̊i[ꏊɈꎞIɃX^bNgp)
		int OldStackP = stackP;
		while (true) {
			T ret = eval(form.car);
			stack[stackP++] = ret;
			if (form.cdr == Null.Nil) break;
			form = (Cons)form.cdr;
		}
		// (2) (V{̉ߋ̒lX^bNɑޔ(1)ŕ]lV{ɓ(Xbv))
		Cons argList = lambda;
		int sp = OldStackP;
		while (true) {
			Symbol sym = (Symbol)argList.car;
			T swap = sym.value;
			sym.value = stack[sp];
			stack[sp++] = swap;
			if (argList.cdr == Null.Nil) break;
			argList = (Cons)argList.cdr;
		}
				
		// body ̕]
		T ret = evalBody(body);
		
		// X^bNO̒lɖ߂
		argList = lambda;
		stackP = OldStackP;
		while (true) {
			Symbol sym = (Symbol)argList.car;
			sym.value = stack[OldStackP++];
			if (argList.cdr == Null.Nil) break;
			argList = (Cons)argList.cdr;
		}
		// lԂ
		return ret;
	}

	/**
	* {̂̕]
	*/
	private static T evalBody(Cons body) throws Exception {
		T ret;
		while (true) {
			ret = eval(body.car);
			if (body.cdr == Null.Nil) break;
			body = (Cons)body.cdr;
		}
		return ret;
	}
}