package info.gomi.lisp.sdlisp;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

/** Xv[_ Reader */
public class Reader {
	private final static int CharBuffSize = 256;	// obt@̃TCY
	private static char[] charBuff = null;			// obt@
	private static char ch;							// 1obt@
	private static String line;						// 1s̓obt@
	private static int indexOfLine = 0;				// 1s̈ʒu
	private static int lineLength = 0;				// 1s̕
	private static BufferedReader br = null;		// java [_
	static {
		br = new BufferedReader(new InputStreamReader(System.in));
		charBuff = new char[CharBuffSize];		
	}

	/** S [_ */
	public static T read() throws IOException{
		line = br.readLine(); // 1sǂݍ
		prepare();
		return getSexp();
	}
	
	/** [_̎O */
	private static void prepare() {
		indexOfLine = 0;
		lineLength = line.length();
		// ̂߂ charArray ֊i[
		line.getChars(0, lineLength, charBuff, 0);
		charBuff[lineLength] = '\0'; // I}[N
		getChar();
	}

	/**
	* z񂩂1ǂݍ ch ɒlZbgAindexOfLine i߂
	*/
	private static void getChar() {
		ch = charBuff[indexOfLine++];
	}

	/**
	* 󔒕̓ǂݔ΂
	*/
	private static void skipSpace() {
		while (Character.isWhitespace(ch)) getChar();
	}

	/**
	* S̓ǂݍ getSexp
	*   ch ͓ǂݍłԂŁÃ\bhĂяo
	*/
	private static T getSexp(){
		while (true) {
			skipSpace();					// 󔒂̓ǂݔ΂
			switch (ch) {
				case '(' :	return makeList();
				case '\'':	return makeQuote();
				case '-' :	return makeMinusNumber();
				default :
					if (Character.isDigit(ch)) return makeNumber();
					return makeSymbol();
			}
		}
	}

	/** ̓ǂݍ makeNumber */
	private static T makeNumber(){
		StringBuilder str = new StringBuilder();
		if (ch == '-') {
			str = str.append(ch);
			getChar();
		}
		for (; indexOfLine <= lineLength; getChar()) {
			if (ch == '(' || ch == ')') break;
			if (Character.isWhitespace(ch)) break;			
			if (!Character.isDigit(ch)) {
				indexOfLine--;
				return makeSymbolInternal(str);
			}
			str.append(ch);
		}
		int value = new java.lang.Integer("" + str).intValue();
		return new Integer(value);
	}

	/** ̓ǂݍ makeMinusNumber */
	private static T makeMinusNumber() {
		char nch = charBuff[indexOfLine]; // ̕
		// - (}CiX) ̏
		if (Character.isDigit(nch) == false) return makeSymbolInternal(new StringBuilder().append(ch));
		return makeNumber();
	}

	/** V{̓ǂݍ makeSymbol */
	private static T makeSymbol() {
		ch = Character.toUpperCase(ch);
		StringBuilder str = new StringBuilder().append(ch);
		return makeSymbolInternal(str);
	}

	/**
	* r̕nẴV{̓ǂݍ
	*   MakeSymbolInternal(StringBuffer)
	*/
	private static T makeSymbolInternal(StringBuilder str) {
		while (indexOfLine < lineLength) {
			getChar();
			if (ch == '(' || ch == ')') break;
			if (Character.isWhitespace(ch)) break;
			ch = Character.toUpperCase(ch);
			str.append(ch);
		}
		String symStr = "" + str;

		if (symStr.equals("NIL")) return Null.Nil; 		// NIL ͓ʂɏ
		return Symbol.symbol(symStr); 
	}

	/** Xg̓ǂݍ makeList */
	private static T makeList() {
		getChar();
		skipSpace(); 				// 󔒂̓ǂݔ΂
		if (ch == ')') { 			// () ̂Ƃ 
			getChar();
			return Null.Nil;
		};
		Cons top = new Cons(Null.Nil, Null.Nil);
		Cons list = top;
		while (true) {
			list.car = getSexp();   // car ̓ǂݍ
			skipSpace(); 			// 󔒂̓ǂݔ΂
			if (indexOfLine > lineLength) return Null.Nil; // ǂݍݓr̂Ƃ NIL
			if (ch == ')') break; 	// close ΏI
			if (ch == '.') { 		// dot pair ̓ǂݍ
				getChar(); 			// dot ̓ǂݔ΂
				list.cdr = getSexp();
				skipSpace(); 		// 󔒂̓ǂݔ΂
				getChar(); 			// close ̓ǂݔ΂
				return top;
			}
			list.cdr = new Cons(Null.Nil, Null.Nil);
			list = (Cons)list.cdr;
		}
		getChar(); 					// close ̓ǂݔ΂
		return top;
	}

	/** NH[g̓ǂݍ makeQuote */
	private static T makeQuote() {
		Cons top = new Cons();
		Cons list = top;
		list.car = Symbol.symbol("QUOTE");
		list.cdr = new Cons();
		list = (Cons)list.cdr;
		getChar();
		list.car = getSexp();
		return top;
	}
}